game.module(
    'game.scenes.mainMenu'
);

game.body(function() {

	game.createScene('MainMenu', {
        backgroundColor: 0xb9bec7,

        init: function() {
            // Google Analytics
            if (navigator.isCocoonJS) {
               game.Analytics.ga.trackView('Main Menu');
            }

            this.addBackground();
            this.addButtons();

            game.Shapes = new game.ClassShapes();
            game.Colors = new game.ClassColors();
        },

        addBackground: function () {
            var background = new game.Sprite('images/game-background.png');
            background.position.set((game.system.width / 2), 0);
            background.anchor.set(0.5, 0);
            background.addTo(this.stage);

            var logo = new game.Sprite('images/menu-logo-brain.png');
            logo.position.set((game.system.width / 2), 250);
            logo.anchor.set(0.5, 0.5);
            logo.addTo(this.stage);

            var tween = new game.Tween(logo.scale)
            .to({x: 0.95, y: 0.92}, 1500)
            .repeat(Infinity)           //.repeat(Infinity)
            .yoyo()
            .easing(game.Tween.Easing.Quadratic.Out)
            .start();


            var logoText = new game.Sprite('images/menu-logo-text.png');
            logoText.position.set((game.system.width / 2), 490);
            logoText.anchor.set(0.5, 0.5);
            logoText.addTo(this.stage);

            var tween = new game.Tween(logoText.position)
            .to({y: logoText.position.y - 10}, 1500)
            .repeat(Infinity)           //.repeat(Infinity)
            .yoyo()
            .easing(game.Tween.Easing.Quadratic.Out)
            .start();


            var sprocketBig = new game.Sprite('images/menu-logo-sprocket-big.png');
            sprocketBig.position.set((logo.position.x + 50), (logo.position.y));
            sprocketBig.anchor.set(0.5, 0.5);
            sprocketBig.addTo(this.stage);

            var sprocketSmall = new game.Sprite('images/menu-logo-sprocket-small.png');
            sprocketSmall.position.set((logo.position.x - 24), (logo.position.y - 28));
            sprocketSmall.anchor.set(0.5, 0.5);
            sprocketSmall.addTo(this.stage);

            var tweenGroup = new game.TweenGroup(function() {
                // console.log('TweenGroup complete');
            });

            var tween1 = new game.Tween(sprocketBig)
            .to({rotation: -6.28}, 3000)     // 360 stupnu je 6.28 radianu
            .repeat(Infinity);          //.repeat(Infinity)

            var tween2 = new game.Tween(sprocketSmall)
            .to({rotation: 6.28}, 3000)     // 360 stupnu je 6.28 radianu
            .repeat(Infinity);           //.repeat(Infinity)

            tweenGroup.add(tween1);
            tweenGroup.add(tween2);
            tweenGroup.start();

        },

        addButtons: function() {
            var btnPlayChallenge = new game.Sprite('images/btn-play-challenge.png');
            btnPlayChallenge.position.set((game.system.width / 2), 750);
            btnPlayChallenge.anchor.set(0.5, 0.5);
            btnPlayChallenge.addTo(this.stage);

            btnPlayChallenge.interactive = true;
            btnPlayChallenge.click = btnPlayChallenge.tap = function() {
                btnPlayChallenge.interactive = false;
                game.audio.playSound('button-click');

                game.challengeTotalPoints = 0;

                game.LevelsChallenge = new game.ClassLevelsChallenge();
                // nastaveni levelu 1
                game.LevelChallenge = new game.ClassLevelChallenge();
                game.LevelChallenge.setLevel(1);

                var tween = new game.Tween(btnPlayChallenge.scale)
                        .to({x: 0.75, y: 0.75}, 200)
                        .repeat(1)
                        .yoyo()
                        .easing(game.Tween.Easing.Quadratic.Out)
                        .onComplete(function () {
                            game.system.setScene('GameChallenge');
                        })
                        .start();
            };


            var btnPlayTraining = new game.Sprite('images/btn-play-training.png');
            btnPlayTraining.position.set((game.system.width / 2), 890);
            btnPlayTraining.anchor.set(0.5, 0.5);
            btnPlayTraining.addTo(this.stage);

            btnPlayTraining.interactive = true;
            btnPlayTraining.click = btnPlayTraining.tap = function() {
                btnPlayTraining.interactive = false;
                game.audio.playSound('button-click');
                var tween = new game.Tween(btnPlayTraining.scale)
                        .to({x: 0.75, y: 0.75}, 200)
                        .repeat(1)
                        .yoyo()
                        .easing(game.Tween.Easing.Quadratic.Out)
                        .onComplete(function () {
                            game.system.setScene('LevelSelectTraining');
                        })
                        .start();
            };


            var btnNativeShare = new game.Sprite('images/btn-native-share.png');
            btnNativeShare.anchor.set(0.5, 0.5);
            btnNativeShare.position.set( (30 + (btnNativeShare.width / 2)), (game.system.height - 28 - (btnNativeShare.height / 2)) );
            btnNativeShare.addTo(this.stage);

            btnNativeShare.interactive = true;
            btnNativeShare.click = btnNativeShare.tap = function() {
                // Google Analytics
                if (navigator.isCocoonJS) {
                    game.Analytics.ga.trackEvent('Player actions', 'Native share btn clicked');
                }

                if (window.cordova) {
                    window.plugins.socialsharing.share('Fun game to train and improve memory and concentration.', 'Visual Memory Challenge', 'http://www.dreamiolab.com/images/memory-challenge-native-share.jpg' /*null*/ /* img */, 'https://play.google.com/store/apps/details?id=com.dreamiolab.memorychallenge');

                    /*
                    // NEFUNGUJE this is the complete list of currently supported params you can pass to the plugin (all optional)
                    var options = {
                        message: 'Fun game to train and improve memory and concentration.', // not supported on some apps (Facebook, Instagram)
                        subject: 'Visual Memory Challenge', // fi. for email
                        files: [], // files: ['', ''],     an array of filenames either locally or remotely  http://www.dreamiolab.com/images/memory-challenge-native-share.jpg
                        url: 'https://play.google.com/store/apps/details?id=com.dreamiolab.memorychallenge',
                        chooserTitle: 'Pick an app', // Android only, you can override the default share sheet title,
                        appPackageName: 'com.dreamiolab.memorychallenge', // Android only, you can provide id of the App you want to share with
                    };

                    var onSuccess = function(result) {
                        //console.log("Share completed? " + result.completed); // On Android apps mostly return false even while it's true
                        //console.log("Shared to app: " + result.app); // On Android result.app since plugin version 5.4.0 this is no longer empty. On iOS it's empty when sharing is cancelled (result.completed=false)
                    };

                    var onError = function(msg) {
                        //console.log("Sharing failed with message: " + msg);
                    };

                    window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);
                    */
                }

            }


            var btnFacebook = new game.Sprite('images/btn-facebook.png');
            btnFacebook.anchor.set(0.5, 0.5);
            btnFacebook.position.set( (110 + (btnFacebook.width / 2)), (game.system.height - 28 - (btnFacebook.height / 2)) );
            btnFacebook.addTo(this.stage);

            btnFacebook.interactive = true;
            btnFacebook.click = btnFacebook.tap = function() {
                // Google Analytics
                if (navigator.isCocoonJS) {
                    game.Analytics.ga.trackEvent('Player actions', 'Facebook btn clicked');
                }

                if (window.cordova) {
                    window.open("https://www.facebook.com/pages/Dreamio-Lab/1464841710483621");
                } else {
                    window.open("https://www.facebook.com/pages/Dreamio-Lab/1464841710483621");
                }
            }

            var btnGoogleplus = new game.Sprite('images/btn-googleplus.png');
            btnGoogleplus.anchor.set(0.5, 0.5);
            btnGoogleplus.position.set( (190 + (btnGoogleplus.width / 2)), (game.system.height - 28 - (btnGoogleplus.height / 2)) );
            btnGoogleplus.addTo(this.stage);

            btnGoogleplus.interactive = true;
            btnGoogleplus.click = btnGoogleplus.tap = function() {
                // Google Analytics
                if (navigator.isCocoonJS) {
                    game.Analytics.ga.trackEvent('Player actions', 'Google plus btn clicked');
                }

                if (window.cordova) {
                    window.open("https://plus.google.com/113569395017732919585/posts");
                } else {
                    window.open("https://plus.google.com/113569395017732919585/posts");
                }
            }

            var btnTwitter = new game.Sprite('images/btn-twitter.png');
            btnTwitter.anchor.set(0.5, 0.5);
            btnTwitter.position.set( (270 + (btnTwitter.width / 2)), (game.system.height - 28 - (btnTwitter.height / 2)) );
            btnTwitter.addTo(this.stage);

            btnTwitter.interactive = true;
            btnTwitter.click = btnTwitter.tap = function() {
                // Google Analytics
                if (navigator.isCocoonJS) {
                    game.Analytics.ga.trackEvent('Player actions', 'Twitter btn clicked');
                }

                if (window.cordova) {
                    window.open("https://twitter.com/DreamioLab");
                } else {
                    window.open("https://twitter.com/DreamioLab");
                }
            }

            

        },

    });





    game.createClass('ClassLevelChallenge', {
        name: '',
        levelNumber: '',

        init: function() {

        },

        setLevel: function(levelId) {
            // nastavi data zvoleneho levelu z objektu leveluu
            //console.log('level selected: ' + levelId);

            this.name = 'Level ' + levelId;
            this.levelNumber = levelId;
            this.patternNumber = game.LevelsChallenge.levels['level' + levelId].patternNumber;
            this.patternSpeed = (401 - (levelId * 1));        //game.LevelsChallenge.levels['level' + levelId].patternSpeed;
            this.clickAnimationSpeed = (this.patternSpeed / 1.5) ;
            //this.clickMystakeAnimationSpeed = (this.clickAnimationSpeed * 1.5);
            this.patternDelay =  ((2 * this.patternSpeed) + 301 - (levelId * 1));        //game.LevelsChallenge.levels['level' + levelId].patternDelay;
            //this.shapesNumber = game.LevelsChallenge.levels['level' + levelId].shapesNumber;
            this.shapeSize = game.LevelsChallenge.levels['level' + levelId].shapeSize;
            this.locationSize = game.LevelsChallenge.levels['level' + levelId].locationSize;
            this.locationsNumber = game.LevelsChallenge.levels['level' + levelId].locations.length;
            this.locations = game.LevelsChallenge.levels['level' + levelId].locations;
            this.levelTime = ( (2 + Math.round(this.patternNumber * 1.5)) * 1000);        // cas v ms
            //this.levelLives = 3;
        },

    });


});
